<template>
  <div class="organisation-invoices">
    <ObTable
      ref="invoices-table"
      :columns="columns"
      :remote-opt="{
        method: api.organisations.getInvoices,
        contentKey: 'accounts'
      }"
      :functional-panel="true"
      :show-add-button="true"
      :is-functional-group="false"
      :is-functional-sort="false"
      :table-layout-fixed="true"
      @add="onAdd"
    >

    </ObTable>

    <ObModal
      ref="add-invoice-modal"
      title="Новый расчётный счёт"
      size="small"
      @closed="onClose"
    >
      <AddInvoice
        ref="add-invoice"
        @close="closeModal"
        :key="addInvoiceRenderKey"
      />
    </ObModal>
  </div>
</template>

<script>
  import api from '@/api'
  import ObTable from 'common-components/src/obComponents/obTable'
  import ObModal from "common-components/src/obComponents/obModal"
  import AddInvoice from '../../modal/add-invoice'

  export default {
    name: 'OrganizationInvoices',
    components: {
      ObTable,
      ObModal,
      AddInvoice
    },
    computed:{
      uuid: ({ $route }) => $route.params.uuid,
    },
    data () {
      return {
        api,
        columns: [
          // {
          //   title: '№',
          //   key: 'order',
          //   exactWidth: '70px',
          //   html: ({ isMain, order }) => this.getHTML(isMain, order)
          // },
          {
            title: 'Тип счета',
            key: 'isMain',
            html: ({ isMain }) => this.getHTML(isMain, isMain ? 'Основной расчетный счет' : 'Расчетный счет')
          },
          {
            title: 'Расчетный счет',
            key: 'paymentAccount',
            html: ({ isMain, paymentAccount }) => this.getHTML(isMain, paymentAccount)
          },
          {
            title: 'БИК',
            key: 'bik',
            html: ({ isMain, bik }) => this.getHTML(isMain, bik)
          },
          {
            title: 'Наименование банка',
            key: 'bank',
            html: ({ isMain, bank }) => this.getHTML(isMain, bank)
          },
          {
            title: 'Корреспондентский счет',
            key: 'correspondentAccount',
            html: ({ isMain, correspondentAccount }) => this.getHTML(isMain, correspondentAccount)
          },
          {
            title: 'Статус',
            key: 'isMain',
            html: ({ isMain }) => this.getActionHTML(isMain),
            action: ({ isMain, uuid }) => this.setInvoiceAsMain(isMain, uuid)
          }
        ],
        addInvoiceRenderKey: 0 // Need for re-render addInvoice after close
      }
    },
    methods: {
      onAdd() {
        this.$refs['add-invoice-modal'].open();
        this.$nextTick(() => {
          this.$refs['add-invoice'].getExistingAccounts();
        })
      },
      closeModal() {
        this.$refs['add-invoice-modal'].close();
      },
      onClose() {
        this.addInvoiceRenderKey += 1;
        this.$refs['invoices-table'].loadData({ init: true });
      },
      getHTML(condition, value) {
        return condition ? `<span class="invoice__bold">${value}</span>` : value
      },
      getActionHTML(isMain) {
        return isMain ?
          '<div class="status status__green"><i class="icon checked"></i> Основной счет</div>' :
          '<div class="status status__blue">Сделать основным</div>'
      },
      async setInvoiceAsMain(isMain, uuid) {
        if (!isMain) {
          await api.organisations.setInvoiceAsMain(uuid);
          this.$notification({ type: 'snackbars', message: `Основной счет изменен` });
          this.$refs['invoices-table'].loadData({ init: true });
        }
      }
    }
  }
</script>

<style lang="scss" scoped>
  .organisation-invoices::v-deep {
    .invoice {
      &__bold {
        font-weight: bold;
      }
    }

    .status {
      cursor: pointer;
      display: flex;
      align-items: center;
      justify-content: space-between;

      &__green {
        color: #00CCA6;
      }

      &__blue {
        color: #0070A6;
      }

      .icon {
        margin-right: 7px;
      }
    }
  }
</style>
